
#include <stlsoft/containers/fixed_array.hpp>

#include <iostream>
#include <stdexcept>

void test(stlsoft::fixed_array_3d<int> const& ar, size_t i0, size_t i1, size_t i2)
{
	std::cout << "ar[" << i0 << ", " << i1 << ", " << i2 << "] is ";

	try
	{
		int	v = ar.at(i0, i1, i2);

		std::cout << v;
	}
	catch(std::out_of_range&)
	{
		std::cout << "out-of-range!";
	}
	catch(std::exception&)
	{
		std::cout << "general exception!";
	}

	std::cout << std::endl;
}

int main()
{
	stlsoft::fixed_array_3d<int>	ar(2, 2, 2);

	{ for(size_t i = 0; i < ar.dimension0() + 1; ++i)
	{
		{ for(size_t j = 0; j < ar.dimension1(); ++j)
		{
			{ for(size_t k = 0; k < ar.dimension2(); ++k)
			{
				test(ar, i, j, k);
			}}
		}}
	}}

	return 0;
}

